<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package florist_bouquet
 */


function florist_bouquet_customize_css() {
    ?>
    <style type="text/css">
        :root {
            --primary-color: <?php echo esc_html( get_theme_mod( 'florist_bouquet_primary_color', '#e62e4a' ) ); ?>;
        }
    </style>
    <?php
}
add_action( 'wp_head', 'florist_bouquet_customize_css' );

function florist_bouquet_add_custom_script_in_footer() {
    if ( get_theme_mod( 'florist_bouquet_enable_sticky_header', false ) ) {
        ?>
        <script>
            jQuery(document).ready(function($) {
                $(window).on('scroll', function() {
                    var scroll = $(window).scrollTop();
                    if (scroll > 0) {
                        $('.bottom-header-part-wrapper.hello').addClass('is-sticky');
                    } else {
                        $('.bottom-header-part-wrapper.hello').removeClass('is-sticky');
                    }
                });
            });
        </script>
        <?php
    }
}
add_action( 'wp_footer', 'florist_bouquet_add_custom_script_in_footer' );

function florist_bouquet_enqueue_selected_fonts() {
    $florist_bouquet_fonts_url = florist_bouquet_get_fonts_url();
    if (!empty($florist_bouquet_fonts_url)) {
        wp_enqueue_style('florist-bouquet-google-fonts', $florist_bouquet_fonts_url, array(), null);
    }
}
add_action('wp_enqueue_scripts', 'florist_bouquet_enqueue_selected_fonts');

function florist_bouquet_layout_customizer_css() {
    $florist_bouquet_margin = get_theme_mod('florist_bouquet_layout_width_margin', 50);
    ?>
    <style type="text/css">
        body.site-boxed--layout #page  {
            margin: 0 <?php echo esc_attr($florist_bouquet_margin); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_layout_customizer_css');

function florist_bouquet_blog_layout_customizer_css() {
    // Retrieve the blog layout option
    $florist_bouquet_blog_layout_option = get_theme_mod('florist_bouquet_blog_layout_option_setting', 'Left');

    // Initialize custom CSS variable
    $florist_bouquet_custom_css = '';

    // Generate custom CSS based on the layout option
    if ($florist_bouquet_blog_layout_option === 'Default') {
        $florist_bouquet_custom_css .= '.mag-post-detail { text-align: center; }';
    } elseif ($florist_bouquet_blog_layout_option === 'Left') {
        $florist_bouquet_custom_css .= '.mag-post-detail { text-align: left; }';
    } elseif ($florist_bouquet_blog_layout_option === 'Right') {
        $florist_bouquet_custom_css .= '.mag-post-detail { text-align: right; }';
    }

    // Output the combined CSS
    ?>
    <style type="text/css">
        <?php echo wp_kses($florist_bouquet_custom_css, array( 'style' => array(), 'text-align' => array() )); ?>
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_blog_layout_customizer_css');

function florist_bouquet_sidebar_width_customizer_css() {
    $florist_bouquet_sidebar_width = get_theme_mod('florist_bouquet_sidebar_width', '30');
    ?>
    <style type="text/css">
        .right-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: auto <?php echo esc_attr($florist_bouquet_sidebar_width); ?>%;
        }
        .left-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: <?php echo esc_attr($florist_bouquet_sidebar_width); ?>% auto;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_sidebar_width_customizer_css');

if ( ! function_exists( 'florist_bouquet_get_page_title' ) ) {
    function florist_bouquet_get_page_title() {
        $florist_bouquet_title = '';

        if (is_404()) {
            $florist_bouquet_title = esc_html__('Page Not Found', 'florist-bouquet');
        } elseif (is_search()) {
            $florist_bouquet_title = esc_html__('Search Results for: ', 'florist-bouquet') . esc_html(get_search_query());
        } elseif (is_home() && !is_front_page()) {
            $florist_bouquet_title = esc_html__('Blogs', 'florist-bouquet');
        } elseif (function_exists('is_shop') && is_shop()) {
            $florist_bouquet_title = esc_html__('Shop', 'florist-bouquet');
        } elseif (is_page()) {
            $florist_bouquet_title = get_the_title();
        } elseif (is_single()) {
            $florist_bouquet_title = get_the_title();
        } elseif (is_archive()) {
            $florist_bouquet_title = get_the_archive_title();
        } else {
            $florist_bouquet_title = get_the_archive_title();
        }

        return apply_filters('florist_bouquet_page_title', $florist_bouquet_title);
    }
}

if ( ! function_exists( 'florist_bouquet_has_page_header' ) ) {
    function florist_bouquet_has_page_header() {
        // Default to true (display header)
        $florist_bouquet_return = true;

        // Custom conditions for disabling the header
        if ('hide-all-devices' === get_theme_mod('florist_bouquet_page_header_visibility', 'all-devices')) {
            $florist_bouquet_return = false;
        }

        // Apply filters and return
        return apply_filters('florist_bouquet_display_page_header', $florist_bouquet_return);
    }
}

if ( ! function_exists( 'florist_bouquet_page_header_style' ) ) {
    function florist_bouquet_page_header_style() {
        $florist_bouquet_style = get_theme_mod('florist_bouquet_page_header_style', 'default');
        return apply_filters('florist_bouquet_page_header_style', $florist_bouquet_style);
    }
}

function florist_bouquet_page_title_customizer_css() {
    $florist_bouquet_layout_option = get_theme_mod('florist_bouquet_page_header_layout', 'left');
    ?>
    <style type="text/css">
        .asterthemes-wrapper.page-header-inner {
            <?php if ($florist_bouquet_layout_option === 'flex') : ?>
                display: flex;
                justify-content: space-between;
                align-items: center;
            <?php else : ?>
                text-align: <?php echo esc_attr($florist_bouquet_layout_option); ?>;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_page_title_customizer_css');

function florist_bouquet_pagetitle_height_css() {
    $florist_bouquet_height = get_theme_mod('florist_bouquet_pagetitle_height', 50);
    ?>
    <style type="text/css">
        header.page-header {
            padding: <?php echo esc_attr($florist_bouquet_height); ?>px 0;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_pagetitle_height_css');

function florist_bouquet_site_logo_width() {
    $florist_bouquet_site_logo_width = get_theme_mod('florist_bouquet_site_logo_width', 150);
    ?>
    <style type="text/css">
        .site-logo img {
            max-width: <?php echo esc_attr($florist_bouquet_site_logo_width); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_site_logo_width');

function florist_bouquet_menu_font_size_css() {
    $florist_bouquet_menu_font_size = get_theme_mod('florist_bouquet_menu_font_size', 15);
    ?>
    <style type="text/css">
        .main-navigation a {
            font-size: <?php echo esc_attr($florist_bouquet_menu_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_menu_font_size_css');

function florist_bouquet_sidebar_widget_font_size_css() {
    $florist_bouquet_sidebar_widget_font_size = get_theme_mod('florist_bouquet_sidebar_widget_font_size', 24);
    ?>
    <style type="text/css">
        h2.wp-block-heading,aside#secondary .widgettitle,aside#secondary .widget-title {
            font-size: <?php echo esc_attr($florist_bouquet_sidebar_widget_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_sidebar_widget_font_size_css');

// Woocommerce Product Sale Position 
function florist_bouquet_product_sale_position_customizer_css() {
    $florist_bouquet_layout_option = get_theme_mod('florist_bouquet_product_sale_position', 'left');
    ?>
    <style type="text/css">
        .woocommerce ul.products li.product .onsale {
            <?php if ($florist_bouquet_layout_option === 'left') : ?>
                right: auto;
                left: 0px;
            <?php else : ?>
                left: auto;
                right: 0px;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_product_sale_position_customizer_css'); 

// Featured Image Dimension
function florist_bouquet_custom_featured_image_css() {
    $florist_bouquet_dimension = get_theme_mod('florist_bouquet_blog_post_featured_image_dimension', 'default');
    $florist_bouquet_width = get_theme_mod('florist_bouquet_blog_post_featured_image_custom_width', '');
    $florist_bouquet_height = get_theme_mod('florist_bouquet_blog_post_featured_image_custom_height', '');
    
    if ($florist_bouquet_dimension === 'custom' && $florist_bouquet_width && $florist_bouquet_height) {
        $florist_bouquet_custom_css = "body:not(.single-post) .mag-post-single .mag-post-img img { width: {$florist_bouquet_width}px !important; height: {$florist_bouquet_height}px !important; }";
        wp_add_inline_style('florist-bouquet-style', $florist_bouquet_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'florist_bouquet_custom_featured_image_css');

// Featured Image Border Radius
function florist_bouquet_featured_image_border_radius_css() {
    $florist_bouquet_featured_image_border_radius = get_theme_mod('florist_bouquet_featured_image_border_radius', 10);
    ?>
    <style type="text/css">  
        .mag-post-single img {
            border-radius: <?php echo esc_attr($florist_bouquet_featured_image_border_radius); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_featured_image_border_radius_css');

// Woocommerce Related Products Settings
function florist_bouquet_related_product_css() {
    $florist_bouquet_related_product_show_hide = get_theme_mod('florist_bouquet_related_product_show_hide', true);

    if ( $florist_bouquet_related_product_show_hide != true) {
        ?>
        <style type="text/css">
            .related.products {
                display: none;
            }
        </style>
        <?php
    }
}
add_action('wp_head', 'florist_bouquet_related_product_css');

//Copyright Alignment
function florist_bouquet_footer_copyright_alignment_css() {
    $florist_bouquet_footer_bottom_align = get_theme_mod( 'florist_bouquet_footer_bottom_align', 'center' );   
    ?>
    <style type="text/css">
        .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
            justify-content: <?php echo esc_attr( $florist_bouquet_footer_bottom_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
                justify-content: center;
                text-align:center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'florist_bouquet_footer_copyright_alignment_css' );

//Copyright Font Size
function florist_bouquet_copyright_font_size_css() {
    $florist_bouquet_copyright_font_size = get_theme_mod('florist_bouquet_copyright_font_size', 16);
    ?>
    <style type="text/css">
        .site-footer-bottom .site-info span {
            font-size: <?php echo esc_attr($florist_bouquet_copyright_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_copyright_font_size_css');

// Preloader Background Color Setting
function florist_bouquet_preloader_background_colors_css() {
    $florist_bouquet_preloader_background_color_setting = get_theme_mod('florist_bouquet_preloader_background_color_setting', '');
        // Only output CSS if a color is set
        if (empty($florist_bouquet_preloader_background_color_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-color: <?php echo esc_attr($florist_bouquet_preloader_background_color_setting); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_preloader_background_colors_css');

// Preloader Background Image Setting
function florist_bouquet_preloader_background_image_css() {
    $florist_bouquet_preloader_background_image_setting = get_theme_mod('florist_bouquet_preloader_background_image_setting', '');
        // Only output CSS if the background image is set
        if (empty($florist_bouquet_preloader_background_image_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-image: url('<?php echo esc_url($florist_bouquet_preloader_background_image_setting); ?>');
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_preloader_background_image_css');

//Footer Heading Alignment
function florist_bouquet_footer_heading_alignment_css() {
    $florist_bouquet_footer_header_align = get_theme_mod( 'florist_bouquet_footer_header_align', 'left' );   
    ?>
    <style type="text/css">
        .site-footer h4, footer#colophon h2.wp-block-heading, footer#colophon .widgettitle, footer#colophon .widget-title {
            text-align: <?php echo esc_attr( $florist_bouquet_footer_header_align ); ?> 
        }
    </style>
    <?php
}
add_action( 'wp_head', 'florist_bouquet_footer_heading_alignment_css' );

//First Capital Letter
function florist_bouquet_show_first_caps() {
	$florist_bouquet_first_caps = get_theme_mod('florist_bouquet_show_first_caps', false);
	$florist_bouquet_css = '';
	if ( $florist_bouquet_first_caps ) {
	$florist_bouquet_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
		    font-size: 55px;
			font-weight: 600;
			margin-right: 6px;
			line-height: 1;
			display: inline-block;
			vertical-align: baseline;
		}';
	} else {
		$florist_bouquet_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
			display: none;
		}';
	}
	wp_add_inline_style( 'florist-bouquet-style', $florist_bouquet_css );
}
add_action( 'wp_enqueue_scripts', 'florist_bouquet_show_first_caps' );

// Topbar Padding Dynamic CSS
function florist_bouquet_topbar_padding_css(){
	$padding = get_theme_mod('florist_bouquet_topbar_padding');
	$custom_css = ".top-header-part{
		padding-top: {$padding}px !important;
		padding-bottom: {$padding}px !important;
	}";
	wp_add_inline_style('florist-bouquet-style',$custom_css);

}
add_action('wp_enqueue_scripts','florist_bouquet_topbar_padding_css');

// Banner Button Color
function florist_bouquet_banner_button_color_css() {
    $btn_color = get_theme_mod('florist_bouquet_banner_btn_color');
	$btn_bg_color = get_theme_mod('florist_bouquet_banner_btn_bg_color');

	$custom_css = '';
    if ( !empty($btn_color) ) {
		$custom_css .= "
		.banner-slider-btn a.asterthemes-button{
			color: {$btn_color};
		}";
	}

	if ( !empty($btn_bg_color) ) {
		$custom_css .= "
		.banner-slider-btn a.asterthemes-button{
			background-color: {$btn_bg_color};
		}";
	}

	wp_add_inline_style('florist-bouquet-style', $custom_css);
}
add_action('wp_enqueue_scripts','florist_bouquet_banner_button_color_css');